import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';

class GalleryViewItem {
  GalleryViewItem({required this.id, required this.url, this.thumbnail});

  final String id;
  final String url;
  final String? thumbnail;
}

class GalleryViewItemThumbnail extends StatelessWidget {
  const GalleryViewItemThumbnail({
    Key? key,
    required this.galleryViewItem,
    this.onTap,
    this.placeholder,
    this.errorWidget,
  }) : super(key: key);

  final GalleryViewItem galleryViewItem;

  final GestureTapCallback? onTap;
  final Widget? placeholder;
  final Widget? errorWidget;
  @override
  Widget build(BuildContext context) {
    return Container(
        padding: const EdgeInsets.symmetric(horizontal: 5.0),
        child: GestureDetector(
            onTap: onTap,
            child: Hero(
                tag: galleryViewItem.id,
                child: CachedNetworkImage(
                  fit: BoxFit.fitHeight,
                  alignment: Alignment.center,
                  imageUrl: galleryViewItem.thumbnail ?? galleryViewItem.url,
                  placeholder: (context, url) => this.placeholder ?? Center(child: CircularProgressIndicator()),
                  errorWidget: (context, url, error) => this.errorWidget ?? Icon(Icons.error),
                ))));
  }
}
